// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: EditorMenus.java
// Classes: EditorMenus
// Original Author: ics125b spring 1996
// $Id: EditorMenus.java,v 1.7 1996/08/18 23:12:09 jrobbins Exp $

package uci.graphedit;

import java.awt.*;
import java.lang.*;

/**
* Class       :  EditorMenus
* Parent      :  Object
* Description :  Contains the menu items of Window
**/

public class EditorMenus extends Object {
  /*Purpose:  the purpose of this class is to create the menu on the windows
    and to handle all menu events. */


  /* Menu items */
  public MenuBar 	menuBar; /* needs-more-work */
  private Menu fileMenu;
  private MenuItem newItem;
  private MenuItem openItem;
  private MenuItem saveItem;
  private MenuItem prefsItem;
  private MenuItem closeItem;
  private MenuItem quitItem;


  private Menu 	editMenu;
  private MenuItem deleteItem;
  private MenuItem disposeItem;
  private MenuItem copyItem;
  private MenuItem cutItem;
  private MenuItem pasteItem;
  private MenuItem executeActionItem;

  
  private Menu viewMenu;
  private MenuItem spawnViewItem;
  private MenuItem zoomInItem;
  private MenuItem zoomOutItem;
  private MenuItem zoomNormalItem;
  private MenuItem adjustGridItem;

  
  private Menu arrangeMenu;
  private MenuItem groupItem;
  private MenuItem ungroupItem;
  
  private Menu alignMenu;
  private MenuItem alignTopsItem;
  private MenuItem alignBottomsItem;
  private MenuItem alignLeftsItem;
  private MenuItem alignRightsItem;
  
  private Menu reorderMenu;
  private MenuItem sendToBackItem;
  private MenuItem bringToFrontItem;
  private MenuItem sendBackwardItem;
  private MenuItem bringForwardItem;

  private Menu attributesMenu;

  private Menu lineColorMenu;
  private MenuItem lineBlackItem;
  private MenuItem lineBlueItem;
  private MenuItem lineCyanItem;
  private MenuItem lineDarkGrayItem;
  private MenuItem lineGrayItem;
  private MenuItem lineGreenItem;
  private MenuItem lineLightGrayItem;
  private MenuItem lineMagentaItem;
  private MenuItem lineOrangeItem;
  private MenuItem linePinkItem;
  private MenuItem lineRedItem;
  private MenuItem lineWhiteItem;
  private MenuItem lineYellowItem;

  private Menu fillColorMenu;
  private MenuItem fillBlackItem;
  private MenuItem fillBlueItem;
  private MenuItem fillCyanItem;
  private MenuItem fillDarkGrayItem;
  private MenuItem fillGrayItem;
  private MenuItem fillGreenItem;
  private MenuItem fillLightGrayItem;
  private MenuItem fillMagentaItem;
  private MenuItem fillOrangeItem;
  private MenuItem fillPinkItem;
  private MenuItem fillRedItem;
  private MenuItem fillWhiteItem;
  private MenuItem fillYellowItem;
  private MenuItem fillTransparentItem;

  private Menu fontMenu;
  private MenuItem helveticaItem;
  private MenuItem timesRomanItem;
  private MenuItem courierItem;
  private MenuItem dialogItem;
  private MenuItem zapfDingbatsItem;

  private MenuItem fontSize10Item;
  private MenuItem fontSize12Item;
  private MenuItem fontSize14Item;
  private MenuItem fontSize24Item;
  private MenuItem fontSize48Item;

  private MenuItem alignTextLeftItem;
  private MenuItem alignTextCenterItem;
  private MenuItem alignTextRightItem;


  Editor parent;

  public EditorMenus(Editor ce) {

    /* Now set up the menu items */
    menuBar = new MenuBar();
    parent = ce;
    /* Initialize the file menu */
    menuBar.add(fileMenu = new Menu("File"));
    fileMenu.add(newItem = new MenuItem("New"));
    newItem.disable();
    fileMenu.add(openItem = new MenuItem("Open"));
    openItem.disable();
    fileMenu.add(saveItem = new MenuItem("Save"));
    saveItem.disable();
    fileMenu.addSeparator();
    fileMenu.add(prefsItem = new MenuItem("Prefernces..."));
    fileMenu.addSeparator();
    fileMenu.add(closeItem = new MenuItem("Close Window"));
    fileMenu.add(quitItem = new MenuItem("Quit"));

    /* Initialize the edit Menu */
    menuBar.add(editMenu = new Menu("Edit"));
    //    editMenu.add(deleteItem = new MenuItem("Delete from view"));
    editMenu.add(disposeItem = new MenuItem("Delete"));
    editMenu.add(copyItem = new MenuItem("Copy"));
    copyItem.disable();
    editMenu.add(cutItem = new MenuItem("Cut"));
    cutItem.disable();
    editMenu.add(pasteItem = new MenuItem("Paste"));
    pasteItem.disable();
    editMenu.addSeparator();
    editMenu.add(executeActionItem = new MenuItem("Execute Action..."));

    /* Initialize the view Menu */
    menuBar.add(viewMenu = new Menu("View"));
    //    editMenu.add(deleteItem = new MenuItem("Delete from view"));
    viewMenu.add(spawnViewItem = new MenuItem("Spawn New View"));
    viewMenu.addSeparator();
    viewMenu.add(zoomInItem = new MenuItem("Zoom In"));
    zoomInItem.disable();
    viewMenu.add(zoomOutItem = new MenuItem("Zoom Out"));
    zoomOutItem.disable();
    viewMenu.add(zoomNormalItem = new MenuItem("Zoom Normal"));
    zoomNormalItem.disable();
    viewMenu.addSeparator();
    viewMenu.add(adjustGridItem = new MenuItem("Adjust Grid"));



    menuBar.add(arrangeMenu = new Menu("Arrange"));

    arrangeMenu.add(groupItem = new MenuItem("Group"));
    groupItem.disable();
    arrangeMenu.add(ungroupItem = new MenuItem("Ungroup"));
    ungroupItem.disable();
    arrangeMenu.add(alignMenu = new Menu("Align"));
    alignMenu.add(alignTopsItem = new MenuItem("Tops"));
    alignMenu.add(alignBottomsItem = new MenuItem("Bottoms"));
    alignMenu.add(alignLeftsItem = new MenuItem("Lefts"));
    alignMenu.add(alignRightsItem = new MenuItem("Rights"));
    arrangeMenu.add(reorderMenu = new Menu("Reorder"));
    reorderMenu.add(sendToBackItem = new MenuItem("To Back"));
    reorderMenu.add(bringToFrontItem = new MenuItem("To Front"));
    reorderMenu.add(sendBackwardItem = new MenuItem("Backward"));
    reorderMenu.add(bringForwardItem = new MenuItem("Forward"));

    menuBar.add(attributesMenu = new Menu("Attributes"));

    /* Initialize the color Menu */
    attributesMenu.add(lineColorMenu = new Menu("LineColor"));
    lineColorMenu.add(lineBlackItem = new MenuItem("Black"));
    lineColorMenu.add(lineBlueItem = new MenuItem("Blue"));
    lineColorMenu.add(lineCyanItem = new MenuItem("Cyan"));
    lineColorMenu.add(lineDarkGrayItem = new MenuItem("DarkGray"));
    lineColorMenu.add(lineGrayItem = new MenuItem("Gray"));
    lineColorMenu.add(lineGreenItem = new MenuItem("Green"));
    lineColorMenu.add(lineLightGrayItem = new MenuItem("LightGray"));
    lineColorMenu.add(lineMagentaItem = new MenuItem("Magenta"));
    lineColorMenu.add(lineOrangeItem = new MenuItem("Orange"));
    lineColorMenu.add(linePinkItem = new MenuItem("Pink"));
    lineColorMenu.add(lineRedItem = new MenuItem("Red"));
    lineColorMenu.add(lineWhiteItem = new MenuItem("White"));
    lineColorMenu.add(lineYellowItem = new MenuItem("Yellow"));


    attributesMenu.add(fillColorMenu = new Menu("FillColor"));
    fillColorMenu.add(fillBlackItem = new MenuItem("Black"));
    fillColorMenu.add(fillBlueItem = new MenuItem("Blue"));
    fillColorMenu.add(fillCyanItem = new MenuItem("Cyan"));
    fillColorMenu.add(fillDarkGrayItem = new MenuItem("DarkGray"));
    fillColorMenu.add(fillGrayItem = new MenuItem("Gray"));
    fillColorMenu.add(fillGreenItem = new MenuItem("Green"));
    fillColorMenu.add(fillLightGrayItem = new MenuItem("LightGray"));
    fillColorMenu.add(fillMagentaItem = new MenuItem("Magenta"));
    fillColorMenu.add(fillOrangeItem = new MenuItem("Orange"));
    fillColorMenu.add(fillPinkItem = new MenuItem("Pink"));
    fillColorMenu.add(fillRedItem = new MenuItem("Red"));
    fillColorMenu.add(fillWhiteItem = new MenuItem("White"));
    fillColorMenu.add(fillYellowItem = new MenuItem("Yellow"));
    fillColorMenu.add(fillTransparentItem = new MenuItem("Transparent"));

    /* Initialize the font Menu */
    attributesMenu.add(fontMenu = new Menu("Font"));
    fontMenu.add(helveticaItem = new MenuItem("Helvetica"));
    fontMenu.add(timesRomanItem = new MenuItem("Times Roman"));
    fontMenu.add(courierItem = new MenuItem("Courier"));
    fontMenu.add(dialogItem = new MenuItem("Dialog"));
    fontMenu.add(zapfDingbatsItem = new MenuItem("Zapf Dingbats"));
    fontMenu.addSeparator();
    fontMenu.add(fontSize10Item = new MenuItem("Size 10"));
    fontMenu.add(fontSize12Item = new MenuItem("Size 12"));
    fontMenu.add(fontSize14Item = new MenuItem("Size 14"));
    fontMenu.add(fontSize24Item = new MenuItem("Size 24"));
    fontMenu.add(fontSize48Item = new MenuItem("Size 48"));
    fontMenu.addSeparator();
    fontMenu.add(alignTextLeftItem = new MenuItem("Left Justify"));
    fontMenu.add(alignTextCenterItem = new MenuItem("Centered"));
    fontMenu.add(alignTextRightItem = new MenuItem("Right Justify"));
    ce.setMenuBar(menuBar);
  }/* constructor */


  public void add(Menu m) {
    menuBar.add(m);
  }

  /**
   *  Method	:  handleMenuEvent
   *  Purpose	:  To handle all menu events
   *  Note		:  This function is called from sampleEditorWindows
   *		:  handleMenuEvent
   **/
  public boolean handleMenuEvent(Event e) {
    Editor ce = parent;
    Action act = null;
    if (e.target == quitItem) act = new ActionQuit();
    else if (e.target == closeItem) parent.close();
    else if (e.target == prefsItem)
      act = new ActionOpenWindow("uci.graphedit.PrefsEditor");
    /*    else if (e.target == saveItem) {
	  parent.callEditorFileDialog(true);
	  }
	  else if (e.target == openItem) {
	  parent.callEditorFileDialog(false);
	  } */
    else if (e.target == executeActionItem)
      act = new ActionOpenWindow("uci.graphedit.ExecuteActionWindow");
    
    
    else if (e.target == spawnViewItem)
      act = new ActionSpawn();
    // else if (e.target == zoomInItem)
    //   (new ActionZoom(ActionZoom.IN)).doIt(e);
    // else if (e.target == zoomOutItem)
    //   (new ActionZoom(ActionZoom.OUT)).doIt(e);
    // else if (e.target == zoomNormalItem)
    //   (new ActionZoom(ActionZoom.NORMAL)).doIt(e);
    else if (e.target == adjustGridItem)
      act = new ActionAdjustGrid();
    
    
    else if (e.target == alignTopsItem)
      act = new ActionAlign(ActionAlign.ALIGN_TOPS);
    else if (e.target == alignBottomsItem)
      act = new ActionAlign(ActionAlign.ALIGN_BOTTOMS);
    else if (e.target == alignLeftsItem)
      act = new ActionAlign(ActionAlign.ALIGN_LEFTS);
    else if (e.target == alignRightsItem)
      act = new ActionAlign(ActionAlign.ALIGN_RIGHTS);
    else if (e.target == deleteItem)
      act = new ActionDelete();
    else if (e.target == sendToBackItem)
      act = new ActionReorder(ActionReorder.SEND_TO_BACK);
    else if (e.target == bringToFrontItem)
      act = new ActionReorder(ActionReorder.BRING_TO_FRONT);
    else if (e.target == sendBackwardItem)
      act = new ActionReorder(ActionReorder.SEND_BACKWARD);
    else if (e.target == bringForwardItem)
      act = new ActionReorder(ActionReorder.BRING_FORWARD);
    else if (e.target == disposeItem)
      act = new ActionDispose();
    else if (e.target == lineBlackItem)
      act = new ActionSetAttr("LineColor", Color.black);
    else if (e.target == lineBlueItem)
      act = new ActionSetAttr("LineColor", Color.blue);
    else if (e.target == lineCyanItem)
      act = new ActionSetAttr("LineColor", Color.cyan);
    else if (e.target == lineDarkGrayItem)
      act = new ActionSetAttr("LineColor", Color.darkGray);
    else if (e.target == lineGrayItem)
      act = new ActionSetAttr("LineColor", Color.gray);
    else if (e.target == lineGreenItem)
      act = new ActionSetAttr("LineColor", Color.green);
    else if (e.target == lineLightGrayItem)
      act = new ActionSetAttr("LineColor", Color.lightGray);
    else if (e.target == lineMagentaItem)
      act = new ActionSetAttr("LineColor", Color.magenta);
    else if (e.target == lineOrangeItem)
      act = new ActionSetAttr("LineColor", Color.orange);
    else if (e.target == linePinkItem)
      act = new ActionSetAttr("LineColor", Color.pink);
    else if (e.target == lineRedItem)
      act = new ActionSetAttr("LineColor", Color.red);
    else if (e.target == lineWhiteItem)
      act = new ActionSetAttr("LineColor", Color.white);
    else if (e.target == lineYellowItem)
      act = new ActionSetAttr("LineColor", Color.yellow);
    
    else if (e.target == fillBlackItem)
      act = new ActionSetAttr("FillColor", Color.black);
    else if (e.target == fillBlueItem)
      act = new ActionSetAttr("FillColor", Color.blue);
    else if (e.target == fillCyanItem)
      act = new ActionSetAttr("FillColor", Color.cyan);
    else if (e.target == fillDarkGrayItem)
      act = new ActionSetAttr("FillColor", Color.darkGray);
    else if (e.target == fillGrayItem)
      act = new ActionSetAttr("FillColor", Color.gray);
    else if (e.target == fillGreenItem)
      act = new ActionSetAttr("FillColor", Color.green);
    else if (e.target == fillLightGrayItem)
      act = new ActionSetAttr("FillColor", Color.lightGray);
    else if (e.target == fillMagentaItem)
    act = new ActionSetAttr("FillColor", Color.magenta);
    else if (e.target == fillOrangeItem)
      act = new ActionSetAttr("FillColor", Color.orange);
    else if (e.target == fillPinkItem)
      act = new ActionSetAttr("FillColor", Color.pink);
    else if (e.target == fillRedItem)
      act = new ActionSetAttr("FillColor", Color.red);
    else if (e.target == fillWhiteItem)
      act = new ActionSetAttr("FillColor", Color.white);
    else if (e.target == fillYellowItem)
      act = new ActionSetAttr("FillColor", Color.yellow);
    else if (e.target == fillTransparentItem)
      act = new ActionSetAttr("FillColor", "Transparent");
    else if (e.target == helveticaItem)
      act = new ActionSetAttr("fontName", "Helvetica");
    else if (e.target == timesRomanItem)
      act = new ActionSetAttr("fontName", "TimesRoman");
    else if (e.target == courierItem)
      act = new ActionSetAttr("fontName", "Courier");
    else if (e.target == dialogItem)
      act = new ActionSetAttr("fontName", "Dialog");
    else if (e.target == zapfDingbatsItem)
      act = new ActionSetAttr("fontName", "ZapfDingbats");
    else if (e.target == fontSize10Item)
      act = new ActionSetAttr("fontSize", new Integer(10));
    else if (e.target == fontSize12Item)
      act = new ActionSetAttr("fontSize", new Integer(12));
    else if (e.target == fontSize14Item)
      act = new ActionSetAttr("fontSize", new Integer(14));
    else if (e.target == fontSize24Item)
      act = new ActionSetAttr("fontSize", new Integer(24));
    else if (e.target == fontSize48Item)
      act = new ActionSetAttr("fontSize", new Integer(48));
    else if (e.target == alignTextLeftItem)
      act = new ActionSetAttr("alignment", "Left");
    else if (e.target == alignTextCenterItem)
      act = new ActionSetAttr("alignment", "Center");
    else if (e.target == alignTextRightItem)
      act = new ActionSetAttr("alignment", "Right");
    else return false;
    
    ce.executeAction(act, e);
    return true;
  }

}/* end class EditorMenus */




