// Copyright (c) 1995, 1996 Regents of the University of California.
// All rights reserved.
//
// This software was developed by the Arcadia project
// at the University of California, Irvine.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the University of California, Irvine.  The name of the
// University may not be used to endorse or promote products derived
// from this software without specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

// File: Example.java
// Classes: Example
// Original Author: ics125b spring 1996
// $Id: Example.java,v 1.5 1996/09/01 00:38:14 jrobbins Exp jrobbins $

package uci.graphedit;

import java.applet.*;
import java.awt.*;
import java.util.*;
import uci.util.*;

public class Example extends Applet {
  public static final 	int WIDTH = 500;
  public static final 	int HEIGHT = 400;
  Editor sampleWin;
  NetList net;

  Palette palette;
  PaletteShape shapePalette;
  PaletteCompound masterPalette;


  public Example() {
    net = new NetList();
    net.name("Sample Network");

    sampleWin = new Editor("Graph Editing Sample", WIDTH, HEIGHT, net);
    sampleWin.move(150,100);
    sampleWin.show();

    palette = new PaletteExample();
    shapePalette = new PaletteShape();
    Vector pals = new Vector();
    pals.addElement(palette);
    pals.addElement(shapePalette);
    masterPalette = new PaletteCompound(pals, "Palette");
    masterPalette.move(10, 300);
    masterPalette.show();    
  }

  public void destroy() {
    if (null != masterPalette) masterPalette.close();
    if (null != sampleWin) sampleWin.close();
    masterPalette = null;
    sampleWin = null;
    net = null;
    palette = null;
    shapePalette = null;
  }



  public static void main(String[] args) {
    Example edit_window = new Example();
    edit_window.init();
  }

  public void start() {  }

  public void init() {
    if (Boolean.getBoolean("shouldPreLoad")) {
      Vector packs = new Vector();
      packs.addElement("uci.graphedit.PackageGraphEdit");
      Preloader.loadPackages(packs);
    }
    Action.register(new ActionDispose());
    Action.register(new ActionDelete());
    Action.register(new ActionSpawn());
    Action.register(new ActionAdjustGrid());
    Action.register(new ActionCreateNode("uci.graphedit.SampleNode",
					 null, false));
    Action.register(new ActionQuit());
    
  }

  public void stop() {
  }

} /* end class Example */
